<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DataTree.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">DataTree.java</span></div><h1>DataTree.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.jute.Index;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.KeeperException.NoNodeException;
import org.apache.zookeeper.Quotas;
import org.apache.zookeeper.StatsTrack;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.Watcher.Event;
import org.apache.zookeeper.Watcher.Event.EventType;
import org.apache.zookeeper.Watcher.Event.KeeperState;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.common.PathTrie;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.data.StatPersisted;
import org.apache.zookeeper.txn.CheckVersionTxn;
import org.apache.zookeeper.txn.CreateTxn;
import org.apache.zookeeper.txn.DeleteTxn;
import org.apache.zookeeper.txn.ErrorTxn;
import org.apache.zookeeper.txn.MultiTxn;
import org.apache.zookeeper.txn.SetACLTxn;
import org.apache.zookeeper.txn.SetDataTxn;
import org.apache.zookeeper.txn.Txn;
import org.apache.zookeeper.txn.TxnHeader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class maintains the tree data structure. It doesn't have any networking
 * or client connection code in it so that it can be tested in a stand alone
 * way.
 * &lt;p&gt;
 * The tree maintains two parallel data structures: a hashtable that maps from
 * full paths to DataNodes and a tree of DataNodes. All accesses to a path is
 * through the hashtable. The tree is traversed only when serializing to disk.
 */
<span class="pc bpc" id="L75" title="1 of 2 branches missed.">public class DataTree {</span>
<span class="fc" id="L76">    private static final Logger LOG = LoggerFactory.getLogger(DataTree.class);</span>

    /**
     * This hashtable provides a fast lookup to the datanodes. The tree is the
     * source of truth and is where all the locking occurs
     */
<span class="fc" id="L82">    private final ConcurrentHashMap&lt;String, DataNode&gt; nodes =</span>
        new ConcurrentHashMap&lt;String, DataNode&gt;();

<span class="fc" id="L85">    private final WatchManager dataWatches = new WatchManager();</span>

<span class="fc" id="L87">    private final WatchManager childWatches = new WatchManager();</span>

    /** the root of zookeeper tree */
    private static final String rootZookeeper = &quot;/&quot;;

    /** the zookeeper nodes that acts as the management and status node **/
    private static final String procZookeeper = Quotas.procZookeeper;

    /** this will be the string thats stored as a child of root */
<span class="fc" id="L96">    private static final String procChildZookeeper = procZookeeper.substring(1);</span>

    /**
     * the zookeeper quota node that acts as the quota management node for
     * zookeeper
     */
    private static final String quotaZookeeper = Quotas.quotaZookeeper;

    /** this will be the string thats stored as a child of /zookeeper */
<span class="fc" id="L105">    private static final String quotaChildZookeeper = quotaZookeeper</span>
<span class="fc" id="L106">            .substring(procZookeeper.length() + 1);</span>

    /**
     * the path trie that keeps track fo the quota nodes in this datatree
     */
<span class="fc" id="L111">    private final PathTrie pTrie = new PathTrie();</span>

    /**
     * This hashtable lists the paths of the ephemeral nodes of a session.
     */
<span class="fc" id="L116">    private final Map&lt;Long, HashSet&lt;String&gt;&gt; ephemerals =</span>
        new ConcurrentHashMap&lt;Long, HashSet&lt;String&gt;&gt;();

    /**
     * this is map from longs to acl's. It saves acl's being stored for each
     * datanode.
     */
<span class="fc" id="L123">    public final Map&lt;Long, List&lt;ACL&gt;&gt; longKeyMap =</span>
        new HashMap&lt;Long, List&lt;ACL&gt;&gt;();

    /**
     * this a map from acls to long.
     */
<span class="fc" id="L129">    public final Map&lt;List&lt;ACL&gt;, Long&gt; aclKeyMap =</span>
        new HashMap&lt;List&lt;ACL&gt;, Long&gt;();

    /**
     * these are the number of acls that we have in the datatree
     */
<span class="fc" id="L135">    protected long aclIndex = 0;</span>

    @SuppressWarnings(&quot;unchecked&quot;)
    public HashSet&lt;String&gt; getEphemerals(long sessionId) {
<span class="fc" id="L139">        HashSet&lt;String&gt; retv = ephemerals.get(sessionId);</span>
<span class="fc bfc" id="L140" title="All 2 branches covered.">        if (retv == null) {</span>
<span class="fc" id="L141">            return new HashSet&lt;String&gt;();</span>
        }
<span class="fc" id="L143">        HashSet&lt;String&gt; cloned = null;</span>
<span class="fc" id="L144">        synchronized (retv) {</span>
<span class="fc" id="L145">            cloned = (HashSet&lt;String&gt;) retv.clone();</span>
<span class="pc" id="L146">        }</span>
<span class="fc" id="L147">        return cloned;</span>
    }

    public Map&lt;Long, HashSet&lt;String&gt;&gt; getEphemeralsMap() {
<span class="fc" id="L151">        return ephemerals;</span>
    }

    private long incrementIndex() {
<span class="fc" id="L155">        return ++aclIndex;</span>
    }

    /**
     * compare two list of acls. if there elements are in the same order and the
     * same size then return true else return false
     *
     * @param lista
     *            the list to be compared
     * @param listb
     *            the list to be compared
     * @return true if and only if the lists are of the same size and the
     *         elements are in the same order in lista and listb
     */
    private boolean listACLEquals(List&lt;ACL&gt; lista, List&lt;ACL&gt; listb) {
<span class="nc bnc" id="L170" title="All 2 branches missed.">        if (lista.size() != listb.size()) {</span>
<span class="nc" id="L171">            return false;</span>
        }
<span class="nc bnc" id="L173" title="All 2 branches missed.">        for (int i = 0; i &lt; lista.size(); i++) {</span>
<span class="nc" id="L174">            ACL a = lista.get(i);</span>
<span class="nc" id="L175">            ACL b = listb.get(i);</span>
<span class="nc bnc" id="L176" title="All 2 branches missed.">            if (!a.equals(b)) {</span>
<span class="nc" id="L177">                return false;</span>
            }
        }
<span class="nc" id="L180">        return true;</span>
    }

    /**
     * converts the list of acls to a list of longs.
     *
     * @param acls
     * @return a list of longs that map to the acls
     */
    public synchronized Long convertAcls(List&lt;ACL&gt; acls) {
<span class="fc bfc" id="L190" title="All 2 branches covered.">        if (acls == null)</span>
<span class="fc" id="L191">            return -1L;</span>
        // get the value from the map
<span class="fc" id="L193">        Long ret = aclKeyMap.get(acls);</span>
        // could not find the map
<span class="fc bfc" id="L195" title="All 2 branches covered.">        if (ret != null)</span>
<span class="fc" id="L196">            return ret;</span>
<span class="fc" id="L197">        long val = incrementIndex();</span>
<span class="fc" id="L198">        longKeyMap.put(val, acls);</span>
<span class="fc" id="L199">        aclKeyMap.put(acls, val);</span>
<span class="fc" id="L200">        return val;</span>
    }

    /**
     * converts a list of longs to a list of acls.
     *
     * @param longVal
     *            the list of longs
     * @return a list of ACLs that map to longs
     */
    public synchronized List&lt;ACL&gt; convertLong(Long longVal) {
<span class="pc bpc" id="L211" title="1 of 2 branches missed.">        if (longVal == null)</span>
<span class="nc" id="L212">            return null;</span>
<span class="fc bfc" id="L213" title="All 2 branches covered.">        if (longVal == -1L)</span>
<span class="fc" id="L214">            return Ids.OPEN_ACL_UNSAFE;</span>
<span class="fc" id="L215">        List&lt;ACL&gt; acls = longKeyMap.get(longVal);</span>
<span class="pc bpc" id="L216" title="1 of 2 branches missed.">        if (acls == null) {</span>
<span class="nc" id="L217">            LOG.error(&quot;ERROR: ACL not available for long &quot; + longVal);</span>
<span class="nc" id="L218">            throw new RuntimeException(&quot;Failed to fetch acls for &quot; + longVal);</span>
        }
<span class="fc" id="L220">        return acls;</span>
    }

    public Collection&lt;Long&gt; getSessions() {
<span class="fc" id="L224">        return ephemerals.keySet();</span>
    }

    /**
     * just an accessor method to allow raw creation of datatree's from a bunch
     * of datanodes
     *
     * @param path
     *            the path of the datanode
     * @param node
     *            the datanode corresponding to this path
     */
    public void addDataNode(String path, DataNode node) {
<span class="fc" id="L237">        nodes.put(path, node);</span>
<span class="fc" id="L238">    }</span>

    public DataNode getNode(String path) {
<span class="fc" id="L241">        return nodes.get(path);</span>
    }

    public int getNodeCount() {
<span class="fc" id="L245">        return nodes.size();</span>
    }

    public int getWatchCount() {
<span class="fc" id="L249">        return dataWatches.size() + childWatches.size();</span>
    }

    public int getEphemeralsCount() {
<span class="fc" id="L253">        Map&lt;Long, HashSet&lt;String&gt;&gt; map = this.getEphemeralsMap();</span>
<span class="fc" id="L254">        int result = 0;</span>
<span class="pc bpc" id="L255" title="1 of 2 branches missed.">        for (HashSet&lt;String&gt; set : map.values()) {</span>
<span class="nc" id="L256">            result += set.size();</span>
<span class="nc" id="L257">        }</span>
<span class="fc" id="L258">        return result;</span>
    }

    /**
     * Get the size of the nodes based on path and data length.
     *
     * @return size of the data
     */
    public long approximateDataSize() {
<span class="fc" id="L267">        long result = 0;</span>
<span class="fc bfc" id="L268" title="All 2 branches covered.">        for (Map.Entry&lt;String, DataNode&gt; entry : nodes.entrySet()) {</span>
<span class="fc" id="L269">            DataNode value = entry.getValue();</span>
<span class="fc" id="L270">            synchronized (value) {</span>
<span class="fc" id="L271">                result += entry.getKey().length();</span>
<span class="pc bpc" id="L272" title="1 of 2 branches missed.">                result += (value.data == null ? 0</span>
                        : value.data.length);
<span class="pc" id="L274">            }</span>
<span class="fc" id="L275">        }</span>
<span class="fc" id="L276">        return result;</span>
    }

    /**
     * This is a pointer to the root of the DataTree. It is the source of truth,
     * but we usually use the nodes hashmap to find nodes in the tree.
     */
<span class="fc" id="L283">    private DataNode root = new DataNode(null, new byte[0], -1L,</span>
            new StatPersisted());

    /**
     * create a /zookeeper filesystem that is the proc filesystem of zookeeper
     */
<span class="fc" id="L289">    private DataNode procDataNode = new DataNode(root, new byte[0], -1L,</span>
            new StatPersisted());

    /**
     * create a /zookeeper/quota node for maintaining quota properties for
     * zookeeper
     */
<span class="fc" id="L296">    private DataNode quotaDataNode = new DataNode(procDataNode, new byte[0],</span>
<span class="fc" id="L297">            -1L, new StatPersisted());</span>

<span class="fc" id="L299">    public DataTree() {</span>
        /* Rather than fight it, let root have an alias */
<span class="fc" id="L301">        nodes.put(&quot;&quot;, root);</span>
<span class="fc" id="L302">        nodes.put(rootZookeeper, root);</span>

        /** add the proc node and quota node */
<span class="fc" id="L305">        root.addChild(procChildZookeeper);</span>
<span class="fc" id="L306">        nodes.put(procZookeeper, procDataNode);</span>

<span class="fc" id="L308">        procDataNode.addChild(quotaChildZookeeper);</span>
<span class="fc" id="L309">        nodes.put(quotaZookeeper, quotaDataNode);</span>
<span class="fc" id="L310">    }</span>

    /**
     * is the path one of the special paths owned by zookeeper.
     *
     * @param path
     *            the path to be checked
     * @return true if a special path. false if not.
     */
    boolean isSpecialPath(String path) {
<span class="pc bpc" id="L320" title="1 of 4 branches missed.">        if (rootZookeeper.equals(path) || procZookeeper.equals(path)</span>
<span class="pc bpc" id="L321" title="1 of 2 branches missed.">                || quotaZookeeper.equals(path)) {</span>
<span class="fc" id="L322">            return true;</span>
        }
<span class="fc" id="L324">        return false;</span>
    }

    static public void copyStatPersisted(StatPersisted from, StatPersisted to) {
<span class="fc" id="L328">        to.setAversion(from.getAversion());</span>
<span class="fc" id="L329">        to.setCtime(from.getCtime());</span>
<span class="fc" id="L330">        to.setCversion(from.getCversion());</span>
<span class="fc" id="L331">        to.setCzxid(from.getCzxid());</span>
<span class="fc" id="L332">        to.setMtime(from.getMtime());</span>
<span class="fc" id="L333">        to.setMzxid(from.getMzxid());</span>
<span class="fc" id="L334">        to.setPzxid(from.getPzxid());</span>
<span class="fc" id="L335">        to.setVersion(from.getVersion());</span>
<span class="fc" id="L336">        to.setEphemeralOwner(from.getEphemeralOwner());</span>
<span class="fc" id="L337">    }</span>

    static public void copyStat(Stat from, Stat to) {
<span class="fc" id="L340">        to.setAversion(from.getAversion());</span>
<span class="fc" id="L341">        to.setCtime(from.getCtime());</span>
<span class="fc" id="L342">        to.setCversion(from.getCversion());</span>
<span class="fc" id="L343">        to.setCzxid(from.getCzxid());</span>
<span class="fc" id="L344">        to.setMtime(from.getMtime());</span>
<span class="fc" id="L345">        to.setMzxid(from.getMzxid());</span>
<span class="fc" id="L346">        to.setPzxid(from.getPzxid());</span>
<span class="fc" id="L347">        to.setVersion(from.getVersion());</span>
<span class="fc" id="L348">        to.setEphemeralOwner(from.getEphemeralOwner());</span>
<span class="fc" id="L349">        to.setDataLength(from.getDataLength());</span>
<span class="fc" id="L350">        to.setNumChildren(from.getNumChildren());</span>
<span class="fc" id="L351">    }</span>

    /**
     * update the count of this stat datanode
     *
     * @param lastPrefix
     *            the path of the node that is quotaed.
     * @param diff
     *            the diff to be added to the count
     */
    public void updateCount(String lastPrefix, int diff) {
<span class="fc" id="L362">        String statNode = Quotas.statPath(lastPrefix);</span>
<span class="fc" id="L363">        DataNode node = nodes.get(statNode);</span>
<span class="fc" id="L364">        StatsTrack updatedStat = null;</span>
<span class="pc bpc" id="L365" title="1 of 2 branches missed.">        if (node == null) {</span>
            // should not happen
<span class="nc" id="L367">            LOG.error(&quot;Missing count node for stat &quot; + statNode);</span>
<span class="nc" id="L368">            return;</span>
        }
<span class="fc" id="L370">        synchronized (node) {</span>
<span class="fc" id="L371">            updatedStat = new StatsTrack(new String(node.data));</span>
<span class="fc" id="L372">            updatedStat.setCount(updatedStat.getCount() + diff);</span>
<span class="fc" id="L373">            node.data = updatedStat.toString().getBytes();</span>
<span class="pc" id="L374">        }</span>
        // now check if the counts match the quota
<span class="fc" id="L376">        String quotaNode = Quotas.quotaPath(lastPrefix);</span>
<span class="fc" id="L377">        node = nodes.get(quotaNode);</span>
<span class="fc" id="L378">        StatsTrack thisStats = null;</span>
<span class="pc bpc" id="L379" title="1 of 2 branches missed.">        if (node == null) {</span>
            // should not happen
<span class="nc" id="L381">            LOG.error(&quot;Missing count node for quota &quot; + quotaNode);</span>
<span class="nc" id="L382">            return;</span>
        }
<span class="fc" id="L384">        synchronized (node) {</span>
<span class="fc" id="L385">            thisStats = new StatsTrack(new String(node.data));</span>
<span class="pc" id="L386">        }</span>
<span class="pc bpc" id="L387" title="2 of 4 branches missed.">        if (thisStats.getCount() &gt; -1 &amp;&amp; (thisStats.getCount() &lt; updatedStat.getCount())) {</span>
<span class="nc" id="L388">            LOG</span>
<span class="nc" id="L389">            .warn(&quot;Quota exceeded: &quot; + lastPrefix + &quot; count=&quot;</span>
<span class="nc" id="L390">                    + updatedStat.getCount() + &quot; limit=&quot;</span>
<span class="nc" id="L391">                    + thisStats.getCount());</span>
        }
<span class="fc" id="L393">    }</span>

    /**
     * update the count of bytes of this stat datanode
     *
     * @param lastPrefix
     *            the path of the node that is quotaed
     * @param diff
     *            the diff to added to number of bytes
     * @throws IOException
     *             if path is not found
     */
    public void updateBytes(String lastPrefix, long diff) {
<span class="fc" id="L406">        String statNode = Quotas.statPath(lastPrefix);</span>
<span class="fc" id="L407">        DataNode node = nodes.get(statNode);</span>
<span class="pc bpc" id="L408" title="1 of 2 branches missed.">        if (node == null) {</span>
            // should never be null but just to make
            // findbugs happy
<span class="nc" id="L411">            LOG.error(&quot;Missing stat node for bytes &quot; + statNode);</span>
<span class="nc" id="L412">            return;</span>
        }
<span class="fc" id="L414">        StatsTrack updatedStat = null;</span>
<span class="fc" id="L415">        synchronized (node) {</span>
<span class="fc" id="L416">            updatedStat = new StatsTrack(new String(node.data));</span>
<span class="fc" id="L417">            updatedStat.setBytes(updatedStat.getBytes() + diff);</span>
<span class="fc" id="L418">            node.data = updatedStat.toString().getBytes();</span>
<span class="pc" id="L419">        }</span>
        // now check if the bytes match the quota
<span class="fc" id="L421">        String quotaNode = Quotas.quotaPath(lastPrefix);</span>
<span class="fc" id="L422">        node = nodes.get(quotaNode);</span>
<span class="pc bpc" id="L423" title="1 of 2 branches missed.">        if (node == null) {</span>
            // should never be null but just to make
            // findbugs happy
<span class="nc" id="L426">            LOG.error(&quot;Missing quota node for bytes &quot; + quotaNode);</span>
<span class="nc" id="L427">            return;</span>
        }
<span class="fc" id="L429">        StatsTrack thisStats = null;</span>
<span class="fc" id="L430">        synchronized (node) {</span>
<span class="fc" id="L431">            thisStats = new StatsTrack(new String(node.data));</span>
<span class="pc" id="L432">        }</span>
<span class="pc bpc" id="L433" title="2 of 4 branches missed.">        if (thisStats.getBytes() &gt; -1 &amp;&amp; (thisStats.getBytes() &lt; updatedStat.getBytes())) {</span>
<span class="fc" id="L434">            LOG</span>
<span class="fc" id="L435">            .warn(&quot;Quota exceeded: &quot; + lastPrefix + &quot; bytes=&quot;</span>
<span class="fc" id="L436">                    + updatedStat.getBytes() + &quot; limit=&quot;</span>
<span class="fc" id="L437">                    + thisStats.getBytes());</span>
        }
<span class="fc" id="L439">    }</span>

    /**
     * @param path
     * @param data
     * @param acl
     * @param ephemeralOwner
     *            the session id that owns this node. -1 indicates this is not
     *            an ephemeral node.
     * @param zxid
     * @param time
     * @return the patch of the created node
     * @throws KeeperException
     */
    public String createNode(String path, byte data[], List&lt;ACL&gt; acl,
            long ephemeralOwner, int parentCVersion, long zxid, long time)
            throws KeeperException.NoNodeException,
            KeeperException.NodeExistsException {
<span class="fc" id="L457">        int lastSlash = path.lastIndexOf('/');</span>
<span class="fc" id="L458">        String parentName = path.substring(0, lastSlash);</span>
<span class="fc" id="L459">        String childName = path.substring(lastSlash + 1);</span>
<span class="fc" id="L460">        StatPersisted stat = new StatPersisted();</span>
<span class="fc" id="L461">        stat.setCtime(time);</span>
<span class="fc" id="L462">        stat.setMtime(time);</span>
<span class="fc" id="L463">        stat.setCzxid(zxid);</span>
<span class="fc" id="L464">        stat.setMzxid(zxid);</span>
<span class="fc" id="L465">        stat.setPzxid(zxid);</span>
<span class="fc" id="L466">        stat.setVersion(0);</span>
<span class="fc" id="L467">        stat.setAversion(0);</span>
<span class="fc" id="L468">        stat.setEphemeralOwner(ephemeralOwner);</span>
<span class="fc" id="L469">        DataNode parent = nodes.get(parentName);</span>
<span class="fc bfc" id="L470" title="All 2 branches covered.">        if (parent == null) {</span>
<span class="fc" id="L471">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L473">        synchronized (parent) {</span>
<span class="fc" id="L474">            Set&lt;String&gt; children = parent.getChildren();</span>
<span class="fc bfc" id="L475" title="All 2 branches covered.">            if (children != null) {</span>
<span class="fc bfc" id="L476" title="All 2 branches covered.">                if (children.contains(childName)) {</span>
<span class="fc" id="L477">                    throw new KeeperException.NodeExistsException();</span>
                }
            }
            
<span class="fc bfc" id="L481" title="All 2 branches covered.">            if (parentCVersion == -1) {</span>
<span class="fc" id="L482">                parentCVersion = parent.stat.getCversion();</span>
<span class="fc" id="L483">                parentCVersion++;</span>
            }    
<span class="fc" id="L485">            parent.stat.setCversion(parentCVersion);</span>
<span class="fc" id="L486">            parent.stat.setPzxid(zxid);</span>
<span class="fc" id="L487">            Long longval = convertAcls(acl);</span>
<span class="fc" id="L488">            DataNode child = new DataNode(parent, data, longval, stat);</span>
<span class="fc" id="L489">            parent.addChild(childName);</span>
<span class="fc" id="L490">            nodes.put(path, child);</span>
<span class="fc bfc" id="L491" title="All 2 branches covered.">            if (ephemeralOwner != 0) {</span>
<span class="fc" id="L492">                HashSet&lt;String&gt; list = ephemerals.get(ephemeralOwner);</span>
<span class="fc bfc" id="L493" title="All 2 branches covered.">                if (list == null) {</span>
<span class="fc" id="L494">                    list = new HashSet&lt;String&gt;();</span>
<span class="fc" id="L495">                    ephemerals.put(ephemeralOwner, list);</span>
                }
<span class="fc" id="L497">                synchronized (list) {</span>
<span class="fc" id="L498">                    list.add(path);</span>
<span class="pc" id="L499">                }</span>
            }
<span class="fc" id="L501">        }</span>
        // now check if its one of the zookeeper node child
<span class="fc bfc" id="L503" title="All 2 branches covered.">        if (parentName.startsWith(quotaZookeeper)) {</span>
            // now check if its the limit node
<span class="fc bfc" id="L505" title="All 2 branches covered.">            if (Quotas.limitNode.equals(childName)) {</span>
                // this is the limit node
                // get the parent and add it to the trie
<span class="fc" id="L508">                pTrie.addPath(parentName.substring(quotaZookeeper.length()));</span>
            }
<span class="fc bfc" id="L510" title="All 2 branches covered.">            if (Quotas.statNode.equals(childName)) {</span>
<span class="fc" id="L511">                updateQuotaForPath(parentName</span>
<span class="fc" id="L512">                        .substring(quotaZookeeper.length()));</span>
            }
        }
        // also check to update the quotas for this node
        String lastPrefix;
<span class="fc bfc" id="L517" title="All 2 branches covered.">        if((lastPrefix = getMaxPrefixWithQuota(path)) != null) {</span>
            // ok we have some match and need to update
<span class="fc" id="L519">            updateCount(lastPrefix, 1);</span>
<span class="pc bpc" id="L520" title="1 of 2 branches missed.">            updateBytes(lastPrefix, data == null ? 0 : data.length);</span>
        }
<span class="fc" id="L522">        dataWatches.triggerWatch(path, Event.EventType.NodeCreated);</span>
<span class="fc bfc" id="L523" title="All 2 branches covered.">        childWatches.triggerWatch(parentName.equals(&quot;&quot;) ? &quot;/&quot; : parentName,</span>
                Event.EventType.NodeChildrenChanged);
<span class="fc" id="L525">        return path;</span>
    }

    /**
     * remove the path from the datatree
     *
     * @param path
     *            the path to of the node to be deleted
     * @param zxid
     *            the current zxid
     * @throws KeeperException.NoNodeException
     */
    public void deleteNode(String path, long zxid)
            throws KeeperException.NoNodeException {
<span class="fc" id="L539">        int lastSlash = path.lastIndexOf('/');</span>
<span class="fc" id="L540">        String parentName = path.substring(0, lastSlash);</span>
<span class="fc" id="L541">        String childName = path.substring(lastSlash + 1);</span>
<span class="fc" id="L542">        DataNode node = nodes.get(path);</span>
<span class="fc bfc" id="L543" title="All 2 branches covered.">        if (node == null) {</span>
<span class="fc" id="L544">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L546">        nodes.remove(path);</span>
<span class="fc" id="L547">        DataNode parent = nodes.get(parentName);</span>
<span class="pc bpc" id="L548" title="1 of 2 branches missed.">        if (parent == null) {</span>
<span class="nc" id="L549">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L551">        synchronized (parent) {</span>
<span class="fc" id="L552">            parent.removeChild(childName);</span>
<span class="fc" id="L553">            parent.stat.setPzxid(zxid);</span>
<span class="fc" id="L554">            long eowner = node.stat.getEphemeralOwner();</span>
<span class="fc bfc" id="L555" title="All 2 branches covered.">            if (eowner != 0) {</span>
<span class="fc" id="L556">                HashSet&lt;String&gt; nodes = ephemerals.get(eowner);</span>
<span class="fc bfc" id="L557" title="All 2 branches covered.">                if (nodes != null) {</span>
<span class="fc" id="L558">                    synchronized (nodes) {</span>
<span class="fc" id="L559">                        nodes.remove(path);</span>
<span class="pc" id="L560">                    }</span>
                }
            }
<span class="fc" id="L563">            node.parent = null;</span>
<span class="pc" id="L564">        }</span>
<span class="pc bpc" id="L565" title="1 of 2 branches missed.">        if (parentName.startsWith(procZookeeper)) {</span>
            // delete the node in the trie.
<span class="nc bnc" id="L567" title="All 2 branches missed.">            if (Quotas.limitNode.equals(childName)) {</span>
                // we need to update the trie
                // as well
<span class="nc" id="L570">                pTrie.deletePath(parentName.substring(quotaZookeeper.length()));</span>
            }
        }

        // also check to update the quotas for this node
        String lastPrefix;
<span class="pc bpc" id="L576" title="1 of 2 branches missed.">        if((lastPrefix = getMaxPrefixWithQuota(path)) != null) {</span>
            // ok we have some match and need to update
<span class="nc" id="L578">            updateCount(lastPrefix, -1);</span>
<span class="nc" id="L579">            int bytes = 0;</span>
<span class="nc" id="L580">            synchronized (node) {</span>
<span class="nc bnc" id="L581" title="All 2 branches missed.">                bytes = (node.data == null ? 0 : -(node.data.length));</span>
<span class="nc" id="L582">            }</span>
<span class="nc" id="L583">            updateBytes(lastPrefix, bytes);</span>
        }
<span class="pc bpc" id="L585" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L586">            ZooTrace.logTraceMessage(LOG, ZooTrace.EVENT_DELIVERY_TRACE_MASK,</span>
                    &quot;dataWatches.triggerWatch &quot; + path);
<span class="nc" id="L588">            ZooTrace.logTraceMessage(LOG, ZooTrace.EVENT_DELIVERY_TRACE_MASK,</span>
                    &quot;childWatches.triggerWatch &quot; + parentName);
        }
<span class="fc" id="L591">        Set&lt;Watcher&gt; processed = dataWatches.triggerWatch(path,</span>
                EventType.NodeDeleted);
<span class="fc" id="L593">        childWatches.triggerWatch(path, EventType.NodeDeleted, processed);</span>
<span class="fc bfc" id="L594" title="All 2 branches covered.">        childWatches.triggerWatch(parentName.equals(&quot;&quot;) ? &quot;/&quot; : parentName,</span>
                EventType.NodeChildrenChanged);
<span class="fc" id="L596">    }</span>

    public Stat setData(String path, byte data[], int version, long zxid,
            long time) throws KeeperException.NoNodeException {
<span class="fc" id="L600">        Stat s = new Stat();</span>
<span class="fc" id="L601">        DataNode n = nodes.get(path);</span>
<span class="fc bfc" id="L602" title="All 2 branches covered.">        if (n == null) {</span>
<span class="fc" id="L603">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L605">        byte lastdata[] = null;</span>
<span class="fc" id="L606">        synchronized (n) {</span>
<span class="fc" id="L607">            lastdata = n.data;</span>
<span class="fc" id="L608">            n.data = data;</span>
<span class="fc" id="L609">            n.stat.setMtime(time);</span>
<span class="fc" id="L610">            n.stat.setMzxid(zxid);</span>
<span class="fc" id="L611">            n.stat.setVersion(version);</span>
<span class="fc" id="L612">            n.copyStat(s);</span>
<span class="pc" id="L613">        }</span>
        // now update if the path is in a quota subtree.
        String lastPrefix;
<span class="pc bpc" id="L616" title="1 of 2 branches missed.">        if((lastPrefix = getMaxPrefixWithQuota(path)) != null) {</span>
<span class="nc bnc" id="L617" title="All 4 branches missed.">          this.updateBytes(lastPrefix, (data == null ? 0 : data.length)</span>
              - (lastdata == null ? 0 : lastdata.length));
        }
<span class="fc" id="L620">        dataWatches.triggerWatch(path, EventType.NodeDataChanged);</span>
<span class="fc" id="L621">        return s;</span>
    }

    /**
     * If there is a quota set, return the appropriate prefix for that quota
     * Else return null
     * @param path The ZK path to check for quota
     * @return Max quota prefix, or null if none
     */
    public String getMaxPrefixWithQuota(String path) {
        // do nothing for the root.
        // we are not keeping a quota on the zookeeper
        // root node for now.
<span class="fc" id="L634">        String lastPrefix = pTrie.findMaxPrefix(path);</span>

<span class="fc bfc" id="L636" title="All 4 branches covered.">        if (!rootZookeeper.equals(lastPrefix) &amp;&amp; !(&quot;&quot;.equals(lastPrefix))) {</span>
<span class="fc" id="L637">            return lastPrefix;</span>
        }
        else {
<span class="fc" id="L640">            return null;</span>
        }
    }

    public byte[] getData(String path, Stat stat, Watcher watcher)
            throws KeeperException.NoNodeException {
<span class="fc" id="L646">        DataNode n = nodes.get(path);</span>
<span class="pc bpc" id="L647" title="1 of 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L648">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L650">        synchronized (n) {</span>
<span class="fc" id="L651">            n.copyStat(stat);</span>
<span class="fc bfc" id="L652" title="All 2 branches covered.">            if (watcher != null) {</span>
<span class="fc" id="L653">                dataWatches.addWatch(path, watcher);</span>
            }
<span class="fc" id="L655">            return n.data;</span>
<span class="nc" id="L656">        }</span>
    }

    public Stat statNode(String path, Watcher watcher)
            throws KeeperException.NoNodeException {
<span class="fc" id="L661">        Stat stat = new Stat();</span>
<span class="fc" id="L662">        DataNode n = nodes.get(path);</span>
<span class="fc bfc" id="L663" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L664">            dataWatches.addWatch(path, watcher);</span>
        }
<span class="fc bfc" id="L666" title="All 2 branches covered.">        if (n == null) {</span>
<span class="fc" id="L667">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L669">        synchronized (n) {</span>
<span class="fc" id="L670">            n.copyStat(stat);</span>
<span class="fc" id="L671">            return stat;</span>
<span class="nc" id="L672">        }</span>
    }

    public List&lt;String&gt; getChildren(String path, Stat stat, Watcher watcher)
            throws KeeperException.NoNodeException {
<span class="fc" id="L677">        DataNode n = nodes.get(path);</span>
<span class="pc bpc" id="L678" title="1 of 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L679">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L681">        synchronized (n) {</span>
<span class="fc bfc" id="L682" title="All 2 branches covered.">            if (stat != null) {</span>
<span class="fc" id="L683">                n.copyStat(stat);</span>
            }
            ArrayList&lt;String&gt; children;
<span class="fc" id="L686">            Set&lt;String&gt; childs = n.getChildren();</span>
<span class="fc bfc" id="L687" title="All 2 branches covered.">            if (childs != null) {</span>
<span class="fc" id="L688">                children = new ArrayList&lt;String&gt;(childs.size());</span>
<span class="fc" id="L689">                children.addAll(childs);</span>
            } else {
<span class="fc" id="L691">                children = new ArrayList&lt;String&gt;(0);</span>
            }

<span class="fc bfc" id="L694" title="All 2 branches covered.">            if (watcher != null) {</span>
<span class="fc" id="L695">                childWatches.addWatch(path, watcher);</span>
            }
<span class="fc" id="L697">            return children;</span>
<span class="nc" id="L698">        }</span>
    }

    public Stat setACL(String path, List&lt;ACL&gt; acl, int version)
            throws KeeperException.NoNodeException {
<span class="fc" id="L703">        Stat stat = new Stat();</span>
<span class="fc" id="L704">        DataNode n = nodes.get(path);</span>
<span class="pc bpc" id="L705" title="1 of 2 branches missed.">        if (n == null) {</span>
<span class="nc" id="L706">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L708">        synchronized (n) {</span>
<span class="fc" id="L709">            n.stat.setAversion(version);</span>
<span class="fc" id="L710">            n.acl = convertAcls(acl);</span>
<span class="fc" id="L711">            n.copyStat(stat);</span>
<span class="fc" id="L712">            return stat;</span>
<span class="nc" id="L713">        }</span>
    }

    @SuppressWarnings(&quot;unchecked&quot;)
    public List&lt;ACL&gt; getACL(String path, Stat stat)
            throws KeeperException.NoNodeException {
<span class="fc" id="L719">        DataNode n = nodes.get(path);</span>
<span class="fc bfc" id="L720" title="All 2 branches covered.">        if (n == null) {</span>
<span class="fc" id="L721">            throw new KeeperException.NoNodeException();</span>
        }
<span class="fc" id="L723">        synchronized (n) {</span>
<span class="fc" id="L724">            n.copyStat(stat);</span>
<span class="fc" id="L725">            return new ArrayList&lt;ACL&gt;(convertLong(n.acl));</span>
<span class="nc" id="L726">        }</span>
    }

<span class="fc" id="L729">    static public class ProcessTxnResult {</span>
        public long clientId;

        public int cxid;

        public long zxid;

        public int err;

        public int type;

        public String path;

        public Stat stat;

        public List&lt;ProcessTxnResult&gt; multiResult;
        
        /**
         * Equality is defined as the clientId and the cxid being the same. This
         * allows us to use hash tables to track completion of transactions.
         *
         * @see java.lang.Object#equals(java.lang.Object)
         */
        @Override
        public boolean equals(Object o) {
<span class="nc bnc" id="L754" title="All 2 branches missed.">            if (o instanceof ProcessTxnResult) {</span>
<span class="nc" id="L755">                ProcessTxnResult other = (ProcessTxnResult) o;</span>
<span class="nc bnc" id="L756" title="All 4 branches missed.">                return other.clientId == clientId &amp;&amp; other.cxid == cxid;</span>
            }
<span class="nc" id="L758">            return false;</span>
        }

        /**
         * See equals() to find the rational for how this hashcode is generated.
         *
         * @see ProcessTxnResult#equals(Object)
         * @see java.lang.Object#hashCode()
         */
        @Override
        public int hashCode() {
<span class="nc" id="L769">            return (int) ((clientId ^ cxid) % Integer.MAX_VALUE);</span>
        }

    }

<span class="fc" id="L774">    public volatile long lastProcessedZxid = 0;</span>

    public ProcessTxnResult processTxn(TxnHeader header, Record txn)
    {
<span class="fc" id="L778">        ProcessTxnResult rc = new ProcessTxnResult();</span>

        try {
<span class="fc" id="L781">            rc.clientId = header.getClientId();</span>
<span class="fc" id="L782">            rc.cxid = header.getCxid();</span>
<span class="fc" id="L783">            rc.zxid = header.getZxid();</span>
<span class="fc" id="L784">            rc.type = header.getType();</span>
<span class="fc" id="L785">            rc.err = 0;</span>
<span class="fc" id="L786">            rc.multiResult = null;</span>
<span class="fc bfc" id="L787" title="All 9 branches covered.">            switch (header.getType()) {</span>
                case OpCode.create:
<span class="fc" id="L789">                    CreateTxn createTxn = (CreateTxn) txn;</span>
<span class="fc" id="L790">                    rc.path = createTxn.getPath();</span>
<span class="fc" id="L791">                    createNode(</span>
<span class="fc" id="L792">                            createTxn.getPath(),</span>
<span class="fc" id="L793">                            createTxn.getData(),</span>
<span class="fc" id="L794">                            createTxn.getAcl(),</span>
<span class="fc bfc" id="L795" title="All 2 branches covered.">                            createTxn.getEphemeral() ? header.getClientId() : 0,</span>
<span class="fc" id="L796">                            createTxn.getParentCVersion(),</span>
<span class="fc" id="L797">                            header.getZxid(), header.getTime());</span>
<span class="fc" id="L798">                    break;</span>
                case OpCode.delete:
<span class="fc" id="L800">                    DeleteTxn deleteTxn = (DeleteTxn) txn;</span>
<span class="fc" id="L801">                    rc.path = deleteTxn.getPath();</span>
<span class="fc" id="L802">                    deleteNode(deleteTxn.getPath(), header.getZxid());</span>
<span class="fc" id="L803">                    break;</span>
                case OpCode.setData:
<span class="fc" id="L805">                    SetDataTxn setDataTxn = (SetDataTxn) txn;</span>
<span class="fc" id="L806">                    rc.path = setDataTxn.getPath();</span>
<span class="fc" id="L807">                    rc.stat = setData(setDataTxn.getPath(), setDataTxn</span>
<span class="fc" id="L808">                            .getData(), setDataTxn.getVersion(), header</span>
<span class="fc" id="L809">                            .getZxid(), header.getTime());</span>
<span class="fc" id="L810">                    break;</span>
                case OpCode.setACL:
<span class="fc" id="L812">                    SetACLTxn setACLTxn = (SetACLTxn) txn;</span>
<span class="fc" id="L813">                    rc.path = setACLTxn.getPath();</span>
<span class="fc" id="L814">                    rc.stat = setACL(setACLTxn.getPath(), setACLTxn.getAcl(),</span>
<span class="fc" id="L815">                            setACLTxn.getVersion());</span>
<span class="fc" id="L816">                    break;</span>
                case OpCode.closeSession:
<span class="fc" id="L818">                    killSession(header.getClientId(), header.getZxid());</span>
<span class="fc" id="L819">                    break;</span>
                case OpCode.error:
<span class="fc" id="L821">                    ErrorTxn errTxn = (ErrorTxn) txn;</span>
<span class="fc" id="L822">                    rc.err = errTxn.getErr();</span>
<span class="fc" id="L823">                    break;</span>
                case OpCode.check:
<span class="fc" id="L825">                    CheckVersionTxn checkTxn = (CheckVersionTxn) txn;</span>
<span class="fc" id="L826">                    rc.path = checkTxn.getPath();</span>
<span class="fc" id="L827">                    break;</span>
                case OpCode.multi:
<span class="fc" id="L829">                    MultiTxn multiTxn = (MultiTxn) txn ;</span>
<span class="fc" id="L830">                    List&lt;Txn&gt; txns = multiTxn.getTxns();</span>
<span class="fc" id="L831">                    rc.multiResult = new ArrayList&lt;ProcessTxnResult&gt;();</span>
<span class="fc" id="L832">                    boolean failed = false;</span>
<span class="fc bfc" id="L833" title="All 2 branches covered.">                    for (Txn subtxn : txns) {</span>
<span class="fc bfc" id="L834" title="All 2 branches covered.">                        if (subtxn.getType() == OpCode.error) {</span>
<span class="fc" id="L835">                            failed = true;</span>
<span class="fc" id="L836">                            break;</span>
                        }
<span class="fc" id="L838">                    }</span>

<span class="fc" id="L840">                    boolean post_failed = false;</span>
<span class="fc bfc" id="L841" title="All 2 branches covered.">                    for (Txn subtxn : txns) {</span>
<span class="fc" id="L842">                        ByteBuffer bb = ByteBuffer.wrap(subtxn.getData());</span>
<span class="fc" id="L843">                        Record record = null;</span>
<span class="pc bpc" id="L844" title="1 of 6 branches missed.">                        switch (subtxn.getType()) {</span>
                            case OpCode.create:
<span class="fc" id="L846">                                record = new CreateTxn();</span>
<span class="fc" id="L847">                                break;</span>
                            case OpCode.delete:
<span class="fc" id="L849">                                record = new DeleteTxn();</span>
<span class="fc" id="L850">                                break;</span>
                            case OpCode.setData:
<span class="fc" id="L852">                                record = new SetDataTxn();</span>
<span class="fc" id="L853">                                break;</span>
                            case OpCode.error:
<span class="fc" id="L855">                                record = new ErrorTxn();</span>
<span class="fc" id="L856">                                post_failed = true;</span>
<span class="fc" id="L857">                                break;</span>
                            case OpCode.check:
<span class="fc" id="L859">                                record = new CheckVersionTxn();</span>
<span class="fc" id="L860">                                break;</span>
                            default:
<span class="nc" id="L862">                                throw new IOException(&quot;Invalid type of op: &quot; + subtxn.getType());</span>
                        }
<span class="pc bpc" id="L864" title="3 of 4 branches missed.">                        assert(record != null);</span>

<span class="fc" id="L866">                        ByteBufferInputStream.byteBuffer2Record(bb, record);</span>
                       
<span class="fc bfc" id="L868" title="All 4 branches covered.">                        if (failed &amp;&amp; subtxn.getType() != OpCode.error){</span>
<span class="pc bpc" id="L869" title="1 of 2 branches missed.">                            int ec = post_failed ? Code.RUNTIMEINCONSISTENCY.intValue() </span>
<span class="fc" id="L870">                                                 : Code.OK.intValue();</span>

<span class="fc" id="L872">                            subtxn.setType(OpCode.error);</span>
<span class="fc" id="L873">                            record = new ErrorTxn(ec);</span>
                        }

<span class="fc bfc" id="L876" title="All 2 branches covered.">                        if (failed) {</span>
<span class="pc bpc" id="L877" title="3 of 4 branches missed.">                            assert(subtxn.getType() == OpCode.error) ;</span>
                        }

<span class="fc" id="L880">                        TxnHeader subHdr = new TxnHeader(header.getClientId(), header.getCxid(),</span>
<span class="fc" id="L881">                                                         header.getZxid(), header.getTime(), </span>
<span class="fc" id="L882">                                                         subtxn.getType());</span>
<span class="fc" id="L883">                        ProcessTxnResult subRc = processTxn(subHdr, record);</span>
<span class="fc" id="L884">                        rc.multiResult.add(subRc);</span>
<span class="fc bfc" id="L885" title="All 4 branches covered.">                        if (subRc.err != 0 &amp;&amp; rc.err == 0) {</span>
<span class="fc" id="L886">                            rc.err = subRc.err ;</span>
                        }
<span class="fc" id="L888">                    }</span>
                    break;
            }
<span class="fc" id="L891">        } catch (KeeperException e) {</span>
<span class="pc bpc" id="L892" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L893">                LOG.debug(&quot;Failed: &quot; + header + &quot;:&quot; + txn, e);</span>
            }
<span class="fc" id="L895">            rc.err = e.code().intValue();</span>
<span class="nc" id="L896">        } catch (IOException e) {</span>
<span class="nc bnc" id="L897" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L898">                LOG.debug(&quot;Failed: &quot; + header + &quot;:&quot; + txn, e);</span>
            }
<span class="fc" id="L900">        }</span>
        /*
         * A snapshot might be in progress while we are modifying the data
         * tree. If we set lastProcessedZxid prior to making corresponding
         * change to the tree, then the zxid associated with the snapshot
         * file will be ahead of its contents. Thus, while restoring from
         * the snapshot, the restore method will not apply the transaction
         * for zxid associated with the snapshot file, since the restore
         * method assumes that transaction to be present in the snapshot.
         *
         * To avoid this, we first apply the transaction and then modify
         * lastProcessedZxid.  During restore, we correctly handle the
         * case where the snapshot contains data ahead of the zxid associated
         * with the file.
         */
<span class="fc bfc" id="L915" title="All 2 branches covered.">        if (rc.zxid &gt; lastProcessedZxid) {</span>
<span class="fc" id="L916">        	lastProcessedZxid = rc.zxid;</span>
        }

        /*
         * Snapshots are taken lazily. It can happen that the child
         * znodes of a parent are created after the parent
         * is serialized. Therefore, while replaying logs during restore, a
         * create might fail because the node was already
         * created.
         *
         * After seeing this failure, we should increment
         * the cversion of the parent znode since the parent was serialized
         * before its children.
         *
         * Note, such failures on DT should be seen only during
         * restore.
         */
<span class="fc bfc" id="L933" title="All 2 branches covered.">        if (header.getType() == OpCode.create &amp;&amp;</span>
<span class="fc bfc" id="L934" title="All 2 branches covered.">                rc.err == Code.NODEEXISTS.intValue()) {</span>
<span class="fc" id="L935">            LOG.debug(&quot;Adjusting parent cversion for Txn: &quot; + header.getType() +</span>
                    &quot; path:&quot; + rc.path + &quot; err: &quot; + rc.err);
<span class="fc" id="L937">            int lastSlash = rc.path.lastIndexOf('/');</span>
<span class="fc" id="L938">            String parentName = rc.path.substring(0, lastSlash);</span>
<span class="fc" id="L939">            CreateTxn cTxn = (CreateTxn)txn;</span>
            try {
<span class="fc" id="L941">                setCversionPzxid(parentName, cTxn.getParentCVersion(),</span>
<span class="fc" id="L942">                        header.getZxid());</span>
<span class="nc" id="L943">            } catch (KeeperException.NoNodeException e) {</span>
<span class="nc" id="L944">                LOG.error(&quot;Failed to set parent cversion for: &quot; +</span>
                      parentName, e);
<span class="nc" id="L946">                rc.err = e.code().intValue();</span>
<span class="fc" id="L947">            }</span>
<span class="fc bfc" id="L948" title="All 2 branches covered.">        } else if (rc.err != Code.OK.intValue()) {</span>
<span class="fc" id="L949">            LOG.debug(&quot;Ignoring processTxn failure hdr: &quot; + header.getType() +</span>
                  &quot; : error: &quot; + rc.err);
        }
<span class="fc" id="L952">        return rc;</span>
    }

    void killSession(long session, long zxid) {
        // the list is already removed from the ephemerals
        // so we do not have to worry about synchronizing on
        // the list. This is only called from FinalRequestProcessor
        // so there is no need for synchronization. The list is not
        // changed here. Only create and delete change the list which
        // are again called from FinalRequestProcessor in sequence.
<span class="fc" id="L962">        HashSet&lt;String&gt; list = ephemerals.remove(session);</span>
<span class="fc bfc" id="L963" title="All 2 branches covered.">        if (list != null) {</span>
<span class="fc bfc" id="L964" title="All 2 branches covered.">            for (String path : list) {</span>
                try {
<span class="fc" id="L966">                    deleteNode(path, zxid);</span>
<span class="pc bpc" id="L967" title="1 of 2 branches missed.">                    if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L968">                        LOG</span>
<span class="nc" id="L969">                                .debug(&quot;Deleting ephemeral node &quot; + path</span>
                                        + &quot; for session 0x&quot;
<span class="nc" id="L971">                                        + Long.toHexString(session));</span>
                    }
<span class="nc" id="L973">                } catch (NoNodeException e) {</span>
<span class="nc" id="L974">                    LOG.warn(&quot;Ignoring NoNodeException for path &quot; + path</span>
                            + &quot; while removing ephemeral for dead session 0x&quot;
<span class="nc" id="L976">                            + Long.toHexString(session));</span>
<span class="fc" id="L977">                }</span>
<span class="fc" id="L978">            }</span>
        }
<span class="fc" id="L980">    }</span>

    /**
     * a encapsultaing class for return value
     */
<span class="fc" id="L985">    private static class Counts {</span>
        long bytes;
        int count;
    }

    /**
     * this method gets the count of nodes and the bytes under a subtree
     *
     * @param path
     *            the path to be used
     * @param counts
     *            the int count
     */
    private void getCounts(String path, Counts counts) {
<span class="fc" id="L999">        DataNode node = getNode(path);</span>
<span class="pc bpc" id="L1000" title="1 of 2 branches missed.">        if (node == null) {</span>
<span class="nc" id="L1001">            return;</span>
        }
<span class="fc" id="L1003">        String[] children = null;</span>
<span class="fc" id="L1004">        int len = 0;</span>
<span class="fc" id="L1005">        synchronized (node) {</span>
<span class="fc" id="L1006">            Set&lt;String&gt; childs = node.getChildren();</span>
<span class="fc bfc" id="L1007" title="All 2 branches covered.">            if (childs != null) {</span>
<span class="fc" id="L1008">                children = childs.toArray(new String[childs.size()]);</span>
            }
<span class="pc bpc" id="L1010" title="1 of 2 branches missed.">            len = (node.data == null ? 0 : node.data.length);</span>
<span class="pc" id="L1011">        }</span>
        // add itself
<span class="fc" id="L1013">        counts.count += 1;</span>
<span class="fc" id="L1014">        counts.bytes += len;</span>
<span class="pc bpc" id="L1015" title="1 of 4 branches missed.">        if (children == null || children.length == 0) {</span>
<span class="fc" id="L1016">            return;</span>
        }
<span class="fc bfc" id="L1018" title="All 2 branches covered.">        for (String child : children) {</span>
<span class="fc" id="L1019">            getCounts(path + &quot;/&quot; + child, counts);</span>
        }
<span class="fc" id="L1021">    }</span>

    /**
     * update the quota for the given path
     *
     * @param path
     *            the path to be used
     */
    private void updateQuotaForPath(String path) {
<span class="fc" id="L1030">        Counts c = new Counts();</span>
<span class="fc" id="L1031">        getCounts(path, c);</span>
<span class="fc" id="L1032">        StatsTrack strack = new StatsTrack();</span>
<span class="fc" id="L1033">        strack.setBytes(c.bytes);</span>
<span class="fc" id="L1034">        strack.setCount(c.count);</span>
<span class="fc" id="L1035">        String statPath = Quotas.quotaZookeeper + path + &quot;/&quot; + Quotas.statNode;</span>
<span class="fc" id="L1036">        DataNode node = getNode(statPath);</span>
        // it should exist
<span class="pc bpc" id="L1038" title="1 of 2 branches missed.">        if (node == null) {</span>
<span class="nc" id="L1039">            LOG.warn(&quot;Missing quota stat node &quot; + statPath);</span>
<span class="nc" id="L1040">            return;</span>
        }
<span class="fc" id="L1042">        synchronized (node) {</span>
<span class="fc" id="L1043">            node.data = strack.toString().getBytes();</span>
<span class="pc" id="L1044">        }</span>
<span class="fc" id="L1045">    }</span>

    /**
     * this method traverses the quota path and update the path trie and sets
     *
     * @param path
     */
    private void traverseNode(String path) {
<span class="fc" id="L1053">        DataNode node = getNode(path);</span>
<span class="fc" id="L1054">        String children[] = null;</span>
<span class="fc" id="L1055">        synchronized (node) {</span>
<span class="fc" id="L1056">            Set&lt;String&gt; childs = node.getChildren();</span>
<span class="pc bpc" id="L1057" title="1 of 2 branches missed.">            if (childs != null) {</span>
<span class="nc" id="L1058">                children = childs.toArray(new String[childs.size()]);</span>
            }
<span class="pc" id="L1060">        }</span>
<span class="pc bpc" id="L1061" title="3 of 4 branches missed.">        if (children == null || children.length == 0) {</span>
            // this node does not have a child
            // is the leaf node
            // check if its the leaf node
<span class="fc" id="L1065">            String endString = &quot;/&quot; + Quotas.limitNode;</span>
<span class="pc bpc" id="L1066" title="1 of 2 branches missed.">            if (path.endsWith(endString)) {</span>
                // ok this is the limit node
                // get the real node and update
                // the count and the bytes
<span class="nc" id="L1070">                String realPath = path.substring(Quotas.quotaZookeeper</span>
<span class="nc" id="L1071">                        .length(), path.indexOf(endString));</span>
<span class="nc" id="L1072">                updateQuotaForPath(realPath);</span>
<span class="nc" id="L1073">                this.pTrie.addPath(realPath);</span>
            }
<span class="fc" id="L1075">            return;</span>
        }
<span class="nc bnc" id="L1077" title="All 2 branches missed.">        for (String child : children) {</span>
<span class="nc" id="L1078">            traverseNode(path + &quot;/&quot; + child);</span>
        }
<span class="nc" id="L1080">    }</span>

    /**
     * this method sets up the path trie and sets up stats for quota nodes
     */
    private void setupQuota() {
<span class="fc" id="L1086">        String quotaPath = Quotas.quotaZookeeper;</span>
<span class="fc" id="L1087">        DataNode node = getNode(quotaPath);</span>
<span class="fc bfc" id="L1088" title="All 2 branches covered.">        if (node == null) {</span>
<span class="fc" id="L1089">            return;</span>
        }
<span class="fc" id="L1091">        traverseNode(quotaPath);</span>
<span class="fc" id="L1092">    }</span>

    /**
     * this method uses a stringbuilder to create a new path for children. This
     * is faster than string appends ( str1 + str2).
     *
     * @param oa
     *            OutputArchive to write to.
     * @param path
     *            a string builder.
     * @throws IOException
     * @throws InterruptedException
     */
    void serializeNode(OutputArchive oa, StringBuilder path) throws IOException {
<span class="fc" id="L1106">        String pathString = path.toString();</span>
<span class="fc" id="L1107">        DataNode node = getNode(pathString);</span>
<span class="fc bfc" id="L1108" title="All 2 branches covered.">        if (node == null) {</span>
<span class="fc" id="L1109">            return;</span>
        }
<span class="fc" id="L1111">        String children[] = null;</span>
        DataNode nodeCopy;
<span class="fc" id="L1113">        synchronized (node) {</span>
<span class="fc" id="L1114">            scount++;</span>
<span class="fc" id="L1115">            StatPersisted statCopy = new StatPersisted();</span>
<span class="fc" id="L1116">            copyStatPersisted(node.stat, statCopy);</span>
            //we do not need to make a copy of node.data because the contents
            //are never changed
<span class="fc" id="L1119">            nodeCopy = new DataNode(node.parent, node.data, node.acl, statCopy);</span>
<span class="fc" id="L1120">            Set&lt;String&gt; childs = node.getChildren();</span>
<span class="fc bfc" id="L1121" title="All 2 branches covered.">            if (childs != null) {</span>
<span class="fc" id="L1122">                children = childs.toArray(new String[childs.size()]);</span>
            }
<span class="pc" id="L1124">        }</span>
<span class="fc" id="L1125">        oa.writeString(pathString, &quot;path&quot;);</span>
<span class="fc" id="L1126">        oa.writeRecord(nodeCopy, &quot;node&quot;);</span>
<span class="fc" id="L1127">        path.append('/');</span>
<span class="fc" id="L1128">        int off = path.length();</span>
<span class="fc bfc" id="L1129" title="All 2 branches covered.">        if (children != null) {</span>
<span class="fc bfc" id="L1130" title="All 2 branches covered.">            for (String child : children) {</span>
                // since this is single buffer being resused
                // we need
                // to truncate the previous bytes of string.
<span class="fc" id="L1134">                path.delete(off, Integer.MAX_VALUE);</span>
<span class="fc" id="L1135">                path.append(child);</span>
<span class="fc" id="L1136">                serializeNode(oa, path);</span>
            }
        }
<span class="fc" id="L1139">    }</span>

    int scount;

<span class="fc" id="L1143">    public boolean initialized = false;</span>

    private void deserializeList(Map&lt;Long, List&lt;ACL&gt;&gt; longKeyMap,
            InputArchive ia) throws IOException {
<span class="fc" id="L1147">        int i = ia.readInt(&quot;map&quot;);</span>
<span class="fc bfc" id="L1148" title="All 2 branches covered.">        while (i &gt; 0) {</span>
<span class="fc" id="L1149">            Long val = ia.readLong(&quot;long&quot;);</span>
<span class="fc bfc" id="L1150" title="All 2 branches covered.">            if (aclIndex &lt; val) {</span>
<span class="fc" id="L1151">                aclIndex = val;</span>
            }
<span class="fc" id="L1153">            List&lt;ACL&gt; aclList = new ArrayList&lt;ACL&gt;();</span>
<span class="fc" id="L1154">            Index j = ia.startVector(&quot;acls&quot;);</span>
<span class="fc bfc" id="L1155" title="All 2 branches covered.">            while (!j.done()) {</span>
<span class="fc" id="L1156">                ACL acl = new ACL();</span>
<span class="fc" id="L1157">                acl.deserialize(ia, &quot;acl&quot;);</span>
<span class="fc" id="L1158">                aclList.add(acl);</span>
<span class="fc" id="L1159">                j.incr();</span>
<span class="fc" id="L1160">            }</span>
<span class="fc" id="L1161">            longKeyMap.put(val, aclList);</span>
<span class="fc" id="L1162">            aclKeyMap.put(aclList, val);</span>
<span class="fc" id="L1163">            i--;</span>
<span class="fc" id="L1164">        }</span>
<span class="fc" id="L1165">    }</span>

    private synchronized void serializeList(Map&lt;Long, List&lt;ACL&gt;&gt; longKeyMap,
            OutputArchive oa) throws IOException {
<span class="fc" id="L1169">        oa.writeInt(longKeyMap.size(), &quot;map&quot;);</span>
<span class="fc" id="L1170">        Set&lt;Map.Entry&lt;Long, List&lt;ACL&gt;&gt;&gt; set = longKeyMap.entrySet();</span>
<span class="fc bfc" id="L1171" title="All 2 branches covered.">        for (Map.Entry&lt;Long, List&lt;ACL&gt;&gt; val : set) {</span>
<span class="fc" id="L1172">            oa.writeLong(val.getKey(), &quot;long&quot;);</span>
<span class="fc" id="L1173">            List&lt;ACL&gt; aclList = val.getValue();</span>
<span class="fc" id="L1174">            oa.startVector(aclList, &quot;acls&quot;);</span>
<span class="fc bfc" id="L1175" title="All 2 branches covered.">            for (ACL acl : aclList) {</span>
<span class="fc" id="L1176">                acl.serialize(oa, &quot;acl&quot;);</span>
<span class="fc" id="L1177">            }</span>
<span class="fc" id="L1178">            oa.endVector(aclList, &quot;acls&quot;);</span>
<span class="fc" id="L1179">        }</span>
<span class="fc" id="L1180">    }</span>

    public void serialize(OutputArchive oa, String tag) throws IOException {
<span class="fc" id="L1183">        scount = 0;</span>
<span class="fc" id="L1184">        serializeList(longKeyMap, oa);</span>
<span class="fc" id="L1185">        serializeNode(oa, new StringBuilder(&quot;&quot;));</span>
        // / marks end of stream
        // we need to check if clear had been called in between the snapshot.
<span class="pc bpc" id="L1188" title="1 of 2 branches missed.">        if (root != null) {</span>
<span class="fc" id="L1189">            oa.writeString(&quot;/&quot;, &quot;path&quot;);</span>
        }
<span class="fc" id="L1191">    }</span>

    public void deserialize(InputArchive ia, String tag) throws IOException {
<span class="fc" id="L1194">        deserializeList(longKeyMap, ia);</span>
<span class="fc" id="L1195">        nodes.clear();</span>
<span class="fc" id="L1196">        pTrie.clear();</span>
<span class="fc" id="L1197">        String path = ia.readString(&quot;path&quot;);</span>
<span class="fc bfc" id="L1198" title="All 2 branches covered.">        while (!path.equals(&quot;/&quot;)) {</span>
<span class="fc" id="L1199">            DataNode node = new DataNode();</span>
<span class="fc" id="L1200">            ia.readRecord(node, &quot;node&quot;);</span>
<span class="fc" id="L1201">            nodes.put(path, node);</span>
<span class="fc" id="L1202">            int lastSlash = path.lastIndexOf('/');</span>
<span class="fc bfc" id="L1203" title="All 2 branches covered.">            if (lastSlash == -1) {</span>
<span class="fc" id="L1204">                root = node;</span>
            } else {
<span class="fc" id="L1206">                String parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L1207">                node.parent = nodes.get(parentPath);</span>
<span class="pc bpc" id="L1208" title="1 of 2 branches missed.">                if (node.parent == null) {</span>
<span class="nc" id="L1209">                    throw new IOException(&quot;Invalid Datatree, unable to find &quot; +</span>
                            &quot;parent &quot; + parentPath + &quot; of path &quot; + path);
                }
<span class="fc" id="L1212">                node.parent.addChild(path.substring(lastSlash + 1));</span>
<span class="fc" id="L1213">                long eowner = node.stat.getEphemeralOwner();</span>
<span class="fc bfc" id="L1214" title="All 2 branches covered.">                if (eowner != 0) {</span>
<span class="fc" id="L1215">                    HashSet&lt;String&gt; list = ephemerals.get(eowner);</span>
<span class="fc bfc" id="L1216" title="All 2 branches covered.">                    if (list == null) {</span>
<span class="fc" id="L1217">                        list = new HashSet&lt;String&gt;();</span>
<span class="fc" id="L1218">                        ephemerals.put(eowner, list);</span>
                    }
<span class="fc" id="L1220">                    list.add(path);</span>
                }
            }
<span class="fc" id="L1223">            path = ia.readString(&quot;path&quot;);</span>
<span class="fc" id="L1224">        }</span>
<span class="fc" id="L1225">        nodes.put(&quot;/&quot;, root);</span>
        // we are done with deserializing the
        // the datatree
        // update the quotas - create path trie
        // and also update the stat nodes
<span class="fc" id="L1230">        setupQuota();</span>
<span class="fc" id="L1231">    }</span>

    /**
     * Summary of the watches on the datatree.
     * @param pwriter the output to write to
     */
    public synchronized void dumpWatchesSummary(PrintWriter pwriter) {
<span class="fc" id="L1238">        pwriter.print(dataWatches.toString());</span>
<span class="fc" id="L1239">    }</span>

    /**
     * Write a text dump of all the watches on the datatree.
     * Warning, this is expensive, use sparingly!
     * @param pwriter the output to write to
     */
    public synchronized void dumpWatches(PrintWriter pwriter, boolean byPath) {
<span class="fc" id="L1247">        dataWatches.dumpWatches(pwriter, byPath);</span>
<span class="fc" id="L1248">    }</span>

    /**
     * Write a text dump of all the ephemerals in the datatree.
     * @param pwriter the output to write to
     */
    public void dumpEphemerals(PrintWriter pwriter) {
<span class="fc" id="L1255">        Set&lt;Long&gt; keys = ephemerals.keySet();</span>
<span class="fc" id="L1256">        pwriter.println(&quot;Sessions with Ephemerals (&quot;</span>
<span class="fc" id="L1257">                + keys.size() + &quot;):&quot;);</span>
<span class="fc bfc" id="L1258" title="All 2 branches covered.">        for (long k : keys) {</span>
<span class="fc" id="L1259">            pwriter.print(&quot;0x&quot; + Long.toHexString(k));</span>
<span class="fc" id="L1260">            pwriter.println(&quot;:&quot;);</span>
<span class="fc" id="L1261">            HashSet&lt;String&gt; tmp = ephemerals.get(k);</span>
<span class="fc bfc" id="L1262" title="All 2 branches covered.">            if (tmp != null) {</span>
<span class="fc" id="L1263">                synchronized (tmp) {</span>
<span class="fc bfc" id="L1264" title="All 2 branches covered.">                    for (String path : tmp) {</span>
<span class="fc" id="L1265">                        pwriter.println(&quot;\t&quot; + path);</span>
<span class="fc" id="L1266">                    }</span>
<span class="pc" id="L1267">                }</span>
            }
<span class="fc" id="L1269">        }</span>
<span class="fc" id="L1270">    }</span>

    public void removeCnxn(Watcher watcher) {
<span class="fc" id="L1273">        dataWatches.removeWatcher(watcher);</span>
<span class="fc" id="L1274">        childWatches.removeWatcher(watcher);</span>
<span class="fc" id="L1275">    }</span>

    public void clear() {
<span class="nc" id="L1278">        root = null;</span>
<span class="nc" id="L1279">        nodes.clear();</span>
<span class="nc" id="L1280">        ephemerals.clear();</span>
<span class="nc" id="L1281">    }</span>

    public void setWatches(long relativeZxid, List&lt;String&gt; dataWatches,
            List&lt;String&gt; existWatches, List&lt;String&gt; childWatches,
            Watcher watcher) {
<span class="fc bfc" id="L1286" title="All 2 branches covered.">        for (String path : dataWatches) {</span>
<span class="fc" id="L1287">            DataNode node = getNode(path);</span>
<span class="fc bfc" id="L1288" title="All 2 branches covered.">            if (node == null) {</span>
<span class="fc" id="L1289">                watcher.process(new WatchedEvent(EventType.NodeDeleted,</span>
                            KeeperState.SyncConnected, path));
<span class="pc bpc" id="L1291" title="1 of 2 branches missed.">            } else if (node.stat.getMzxid() &gt; relativeZxid) {</span>
<span class="nc" id="L1292">                watcher.process(new WatchedEvent(EventType.NodeDataChanged,</span>
                            KeeperState.SyncConnected, path));
            } else {
<span class="fc" id="L1295">                this.dataWatches.addWatch(path, watcher);</span>
            }
<span class="fc" id="L1297">        }</span>
<span class="fc bfc" id="L1298" title="All 2 branches covered.">        for (String path : existWatches) {</span>
<span class="fc" id="L1299">            DataNode node = getNode(path);</span>
<span class="pc bpc" id="L1300" title="1 of 2 branches missed.">            if (node != null) {</span>
<span class="nc" id="L1301">                watcher.process(new WatchedEvent(EventType.NodeCreated,</span>
                            KeeperState.SyncConnected, path));
            } else {
<span class="fc" id="L1304">                this.dataWatches.addWatch(path, watcher);</span>
            }
<span class="fc" id="L1306">        }</span>
<span class="fc bfc" id="L1307" title="All 2 branches covered.">        for (String path : childWatches) {</span>
<span class="fc" id="L1308">            DataNode node = getNode(path);</span>
<span class="pc bpc" id="L1309" title="1 of 2 branches missed.">            if (node == null) {</span>
<span class="nc" id="L1310">                watcher.process(new WatchedEvent(EventType.NodeDeleted,</span>
                            KeeperState.SyncConnected, path));
<span class="pc bpc" id="L1312" title="1 of 2 branches missed.">            } else if (node.stat.getPzxid() &gt; relativeZxid) {</span>
<span class="nc" id="L1313">                watcher.process(new WatchedEvent(EventType.NodeChildrenChanged,</span>
                            KeeperState.SyncConnected, path));
            } else {
<span class="fc" id="L1316">                this.childWatches.addWatch(path, watcher);</span>
            }
<span class="fc" id="L1318">        }</span>
<span class="fc" id="L1319">    }</span>

     /**
      * This method sets the Cversion and Pzxid for the specified node to the
      * values passed as arguments. The values are modified only if newCversion
      * is greater than the current Cversion. A NoNodeException is thrown if
      * a znode for the specified path is not found.
      *
      * @param path
      *     Full path to the znode whose Cversion needs to be modified.
      *     A &quot;/&quot; at the end of the path is ignored.
      * @param newCversion
      *     Value to be assigned to Cversion
      * @param zxid
      *     Value to be assigned to Pzxid
      * @throws KeeperException.NoNodeException
      *     If znode not found.
      **/
    public void setCversionPzxid(String path, int newCversion, long zxid)
        throws KeeperException.NoNodeException {
<span class="fc bfc" id="L1339" title="All 2 branches covered.">        if (path.endsWith(&quot;/&quot;)) {</span>
<span class="fc" id="L1340">           path = path.substring(0, path.length() - 1);</span>
        }
<span class="fc" id="L1342">        DataNode node = nodes.get(path);</span>
<span class="pc bpc" id="L1343" title="1 of 2 branches missed.">        if (node == null) {</span>
<span class="nc" id="L1344">            throw new KeeperException.NoNodeException(path);</span>
        }
<span class="fc" id="L1346">        synchronized (node) {</span>
<span class="fc bfc" id="L1347" title="All 2 branches covered.">            if(newCversion == -1) {</span>
<span class="fc" id="L1348">                newCversion = node.stat.getCversion() + 1;</span>
            }
<span class="fc bfc" id="L1350" title="All 2 branches covered.">            if (newCversion &gt; node.stat.getCversion()) {</span>
<span class="fc" id="L1351">                node.stat.setCversion(newCversion);</span>
<span class="fc" id="L1352">                node.stat.setPzxid(zxid);</span>
            }
<span class="pc" id="L1354">        }</span>
<span class="fc" id="L1355">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>